" Fix for Distributed Feature 

  This file in fixes a problem where the name server browser
   and object exchange actions for 

      'ReferencedObject'-> 'Install in Shadow Dictionary', and
      'ReferencedObject'-> 'Install in Smalltalk Dictionary'

  install a remote object into the dictionary rather than a 
  shadow for the object (a shadow is based on an object reference
  and is reconnectable; whereas a remote object is not 
  reconnectable)."


DtNameServerBrowserApplication becomeDefault!

!DtGlobalReference publicMethods !

dtInstallInShadowDictionaryFor: aBrowser
	"Install the selected objects in the browsers shadowdictionary"
	| keyString shadow theObject |
	aBrowser message: NlsBlank.
	aBrowser execLongOperation: [
		shadow := self shadow. 
		theObject := shadow dtYourself.  ].
	theObject dtIsAvailable ifFalse: [
				aBrowser beep;
					message: (self getMRIString: DtMsgReferenceInvalidOrUnavailable group: #DsMessages).
				^nil  ].
 
	keyString := aBrowser shadowDictionary 
				dtPromptForStringKeyAndAdd: shadow
								defaultKeyString: NlsNull
								message: (self getMRIString: DtMsgEnterKeyInShadowDictionary group: #DsMessages).

	keyString isNil ifTrue: [
				aBrowser message: NlsMsgActionCancelled.
				^nil].

	aBrowser message: (self getMRIString: DtMsgObjectInstalledInShadowDictionary group: #DsMessages).
	
!

dtInstallInSmalltalkDictionaryFor: aBrowser
	"Install the selected objects in the browsers shadowdictionary"
	| keyString shadow theObject |
	aBrowser message: NlsBlank.
	aBrowser execLongOperation: [
		shadow := self shadow.
		theObject := shadow dtYourself.  ].
	theObject dtIsAvailable ifFalse: [
				aBrowser beep;
						message: (self getMRIString: DtMsgReferenceInvalidOrUnavailable group: #DsMessages).
				^nil  ].
 
	keyString := Smalltalk
				dtPromptForSymbolKeyAndAdd: shadow
								defaultKeyString: NlsNull
								message: (
									self getMRIString: DtMsgEnterKeyInSmalltalkDictionary group: #DsMessages).

	keyString isNil ifTrue: [
				aBrowser message: NlsMsgActionCancelled.
				^nil].

	aBrowser message: (self getMRIString: DtMsgObjectInstalledInSmalltalkDictionary group: #DsMessages).
	
! !
